#ifndef _GLMDIWINDOW_H_
#define _GLMDIWINDOW_H_

#include "global_define.h"
#include <qmainwindow.h>


class CVolume;
class CGLView;
class MDIWindow;
class CVoxelInfoDlg;


class GLMDIWindow : public QMainWindow
{
	Q_OBJECT

public:
	GLMDIWindow( QWidget *parent = 0, const char *name = 0, WFlags f = 0 );
	~GLMDIWindow();

	CGLView *openglView();

	bool init( CVolume *pVolume );

	CVolume *volume();
	void setMDIWindow( MDIWindow *pMDIWindow );

	bool hasVoxelInfoDlg();

	void setVoxelInfoDlg( CVoxelInfoDlg *pVoxelInfoDlg );
	void unsetVoxelInfoDlg();

	bool resetSegmentation();

	MDIWindow *mdiWindow() { return m_pMDIWindow; }

protected:
	virtual void closeEvent( QCloseEvent * );

public slots:
	bool slotMeshFiltering();
	bool slotMeshFilterInfo();
	bool slotSaveAsImage();
	bool slotAnalysisVolume();

private:
	CVolume *m_pVolume;

	CGLView *m_pGLView;
	MDIWindow *m_pMDIWindow;

	CVoxelInfoDlg *m_pVoxelInfoDlg;
};

#endif // _GLMDIWINDOW_H_
