#ifndef _MDIWINDOW_H_
#define _MDIWINDOW_H_

#include "global_define.h"
#include "define.h"
#include <qmainwindow.h>


class CVolume;
class CPlanView;
class GLMDIWindow;
class RenderMDIWindow;
class MontageMDIWindow;
class MarchingCubeMDIWindow;
class CSegmentationDlg;
class CVoxelInfoDlg;
class QString;


class MDIWindow : public QMainWindow
{
	Q_OBJECT

public:
	MDIWindow( QWidget *parent = 0, const char *name = 0, WFlags f = 0 );
	~MDIWindow();

	CVolume *volume();
	int currentSlice();
	CPlanView *planView();

	// file menu
	bool open( QString fileName );
	bool save( QString fileName );
	bool importStack( KEYWORD key );
	bool exportToAnsys();
	bool exportToSurface( QString fileName, int type );

	bool hasRenderView();
	bool hasOpenGLView();
	bool hasMontageView();
	bool hasMarchingCubeView();
	bool hasSegmentationDlg();

	void setOpenGLView( GLMDIWindow *pGLMDIWindow );
	void unsetOpenGLView();
	void setRenderView( RenderMDIWindow *pRenderMDIWindow );
	void unsetRenderView();
	void setMontageView( MontageMDIWindow *pRenderMDIWindow );
	void unsetMontageView();
	void setMarchingCubeView( MarchingCubeMDIWindow *pMarchingCubeMDIWindow );
	void unsetMarchingCubeView();

	void setSegmentationDlg( CSegmentationDlg *pSegmentationDlg );
	void unsetSegmentationDlg();

	GLMDIWindow *openGLMDIWindow();
	RenderMDIWindow *renderMDIWindow();
	MontageMDIWindow *montageMDIWindow();
	MarchingCubeMDIWindow *marchingCubeMDIWindow();

	bool resampling();

protected:
	virtual void closeEvent( QCloseEvent * );
	virtual bool event( QEvent * );

private:
	CVolume *m_pVolume;

	CPlanView *m_pPlanView;

	RenderMDIWindow *m_pRenderMDIWindow;
	GLMDIWindow *m_pGLMDIWindow;
	MontageMDIWindow *m_pMontageMDIWindow;
	MarchingCubeMDIWindow *m_pMarchingCubeMDIWindow;

	CSegmentationDlg *m_pSegmentationDlg;

	QString m_strVolumeFileName;
};

#endif // _MDIWINDOW_H_
