#ifndef _SEGMENTATIONDLG_H_
#define _SEGMENTATIONDLG_H_

#include "global_define.h"
#include "../BaseDialog/Segmentation/SegmentationDlg_base.h"


class CVolume;
class MDIWindow;


class CSegmentationDlg : public CSegmentationDlg_base
{
	Q_OBJECT

public:
	CSegmentationDlg( QWidget *parent=0, const char *name=0, bool modal=FALSE, WFlags f=0 );
	~CSegmentationDlg();

	void init( MDIWindow *pMDIWindow );

public slots:
	void slotReset();
	void slotResetAll();
	void slotCurrentSlice();
	void slotSegmentAll();

	void slotSliceChanged( int slice );
	void slotMinChanged( int slice );
	void slotMaxChanged( int slice );

protected slots:
	virtual void reject();

private:
	DWORD voxelIndex( int x, int y, int slice );

private:
	MDIWindow *m_pMDIWindow;
	CVolume *m_pVolume;

	WORD *m_pOldMinThreshold;
	WORD *m_pOldMaxThreshold;

	BYTE *m_pMask;

	WORD m_nWidth;
	WORD m_nHeight;
	WORD m_nDepth;
};

#endif // _SEGMENTATIONDLG_H_
