/************************************************************************/
/* MGIBA: Mesh Generator for Image Based Analysis                       */
/* ==============================================                       */
/*                                                                      */
/* Written by Yongchul Kim (blksaint@freechal.com)                      */
/* http://www.diniworld.com                                             */
/*                                                                      */
/* This program is free software. You can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation; either version 2 of the License.       */
/*                                                                      */
/* Please read LICENSE.txt                                              */
/************************************************************************/


#include "global_define.h"
#include "VolumeFile.h"
#include <qthread.h>


class QTextEdit;
class QProgressBar;


class CAnalysisVolumeThread : public QThread
{
public:
	virtual void run();

public:
	void init();

	void resetVolumeStruct();

	void setRunOnOff( bool onoff );

	void setVolume( CVolume *pVolume );
	void setResultWindow( QTextEdit *edit );
	void setResultProgressBar( QProgressBar *progress );

private:
	void analysisVolume();

private:
	VOLUMESTRUCT m_Volume;

	CVolume *m_pVolume;
	QTextEdit *m_pTextEdit;
	QProgressBar *m_pProgressBar;

	BYTE *m_pByteFlag;

	DWORD m_dwTotalNumVoxel;

	bool bRun;
}; // end of class CAnalysisVolumeThread