/************************************************************************/
/* MGIBA: Mesh Generator for Image Based Analysis                       */
/* ==============================================                       */
/*                                                                      */
/* Written by Yongchul Kim (blksaint@freechal.com)                      */
/* http://www.diniworld.com                                             */
/*                                                                      */
/* This program is free software. You can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation; either version 2 of the License.       */
/*                                                                      */
/* Please read LICENSE.txt                                              */
/************************************************************************/


#ifndef _FEMODELSAVEASIMAGEDLG_H_
#define _FEMODELSAVEASIMAGEDLG_H_

#include "global_define.h"
#include "../BaseDialog/Image/FEModelSaveAsImageDlg_base.h"


class GLMDIWindow;


class CFEModelSaveAsImageDlg : public CFEModelSaveAsImageDlg_base
{
	Q_OBJECT

public:
	CFEModelSaveAsImageDlg( QWidget *parent=0, const char *name=0, bool modal=FALSE, WFlags f=0 );
	~CFEModelSaveAsImageDlg();

	bool init( bool output=true );

public slots:
	void slotFileName();
	void slotFileNameChanged( const QString &str );
	void slotOk();
	void slotCancel();

private:
	GLMDIWindow *m_pGLMDIWindow;
}; // end of class CFEModelSaveAsImageDlg

#endif // _FEMODELSAVEASIMAGEDLG_H_
