/************************************************************************/
/* MGIBA: Mesh Generator for Image Based Analysis                       */
/* ==============================================                       */
/*                                                                      */
/* Written by Yongchul Kim (blksaint@freechal.com)                      */
/* http://www.diniworld.com                                             */
/*                                                                      */
/* This program is free software. You can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation; either version 2 of the License.       */
/*                                                                      */
/* Please read LICENSE.txt                                              */
/************************************************************************/


#ifndef _MARCHINGCUBEMDIWINDOW_H_
#define _MARCHINGCUBEMDIWINDOW_H_

#include <qmainwindow.h>


class CVolume;
class CMarchingCubeView;
class MDIWindow;
class vtkImageData;
class vtkMarchingCubes;
class vtkPolyDataMapper;
class vtkLODActor;
class vtkActor;
class vtkOutlineFilter;


class MarchingCubeMDIWindow : public QMainWindow
{
	Q_OBJECT

public:
	MarchingCubeMDIWindow( QWidget *parent = 0, const char *name = 0, WFlags f = 0 );
	~MarchingCubeMDIWindow();

	bool init( CVolume *pVolume );
	
	CVolume *volume();
	CMarchingCubeView *marchingCubeView();

	void setMDIWindow( MDIWindow *pMDIWindow );
	MDIWindow *mdiWindow();

	bool exportToSTL( QString fn );

private:
	CVolume *m_pVolume;
	MDIWindow *m_pMDIWindow;
	CMarchingCubeView *m_pMarchingCubeView;

	vtkImageData *m_pVtkImageData;
	vtkMarchingCubes *m_pVtkMarchingCubes;
	vtkPolyDataMapper *m_pVtkSkinPolyDataMapper;
	vtkPolyDataMapper *m_pVtkOutlinePolyDataMapper;
	vtkOutlineFilter *m_pVtkOutlineFilter ;
	vtkActor *m_pVtkSkinActor;
	vtkActor *m_pVtkOutlineActor;
}; // end of class MarchingCubeMDIWindow

#endif // _MARCHINGCUBEMDIWINDOW_H_