/************************************************************************/
/* MGIBA: Mesh Generator for Image Based Analysis                       */
/* ==============================================                       */
/*                                                                      */
/* Written by Yongchul Kim (blksaint@freechal.com)                      */
/* http://www.diniworld.com                                             */
/*                                                                      */
/* This program is free software. You can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation; either version 2 of the License.       */
/*                                                                      */
/* Please read LICENSE.txt                                              */
/************************************************************************/


#ifndef _MESHFILTERINGDLG_H_
#define _MESHFILTERINGDLG_H_

#include "global_define.h"
#include "../BaseDialog/MeshFiltering/MeshFilteringDlg_base.h"


class GLMDIWindow;
class QString;


class CMeshFilteringDlg : public CMeshFilteringDlg_base
{
	Q_OBJECT
public:
	CMeshFilteringDlg( QWidget *parent=0, const char *name=0, bool modal=FALSE, WFlags f=0 );
	~CMeshFilteringDlg();

	bool init( GLMDIWindow *pGLMDIWindow );

public slots:
	void slotContactStateChanged();
	void slotFilterStateChanged();
	void slotOk();
	void slotCancel();

private:
	GLMDIWindow *m_pGLMDIWindow;

	QString m_strMsgContact;
	QString m_strMsgFilter;
}; // end of class CMeshFilteringDlg

#endif // _MESHFILTERINGDLG_H_
