/************************************************************************/
/* MGIBA: Mesh Generator for Image Based Analysis                       */
/* ==============================================                       */
/*                                                                      */
/* Written by Yongchul Kim (blksaint@freechal.com)                      */
/* http://www.diniworld.com                                             */
/*                                                                      */
/* This program is free software. You can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation; either version 2 of the License.       */
/*                                                                      */
/* Please read LICENSE.txt                                              */
/************************************************************************/


#ifndef _MONTAGEMDIWINDOW_H_
#define _MONTAGEMDIWINDOW_H_

#include <qmainwindow.h>


class CVolume;
class CMontageView;
class MDIWindow;


class MontageMDIWindow : public QMainWindow
{
	Q_OBJECT

public:
	MontageMDIWindow( QWidget *parent=0, const char *name=0, WFlags f=0 );
	~MontageMDIWindow();
	
	bool init( CVolume *pVolume, int nSlice );

	void setMDIWindow( MDIWindow *pMDIWindow );
	
	MDIWindow *mdiWindow();
	CMontageView *montageView();
	CVolume *volume();
	
private:
	MDIWindow *m_pMDIWindow;
	CVolume *m_pVolume;
	CMontageView *m_pMontageView;
}; // end of class MontageMDIWindow

#endif // _MONTAGEMDIWINDOW_H_	
