/************************************************************************/
/* MGIBA: Mesh Generator for Image Based Analysis                       */
/* ==============================================                       */
/*                                                                      */
/* Written by Yongchul Kim (blksaint@freechal.com)                      */
/* http://www.diniworld.com                                             */
/*                                                                      */
/* This program is free software. You can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation; either version 2 of the License.       */
/*                                                                      */
/* Please read LICENSE.txt                                              */
/************************************************************************/


#ifndef _MULTILINEEDITDLG_H_
#define _MULTILINEEDITDLG_H_

#include "global_define.h"
#include "../BaseDialog/Report/MultiLineEditDlg_base.h"

class CMultiLineEditDlg : public CMultiLineEditDlg_base
{
	Q_OBJECT
public:
	CMultiLineEditDlg( QWidget *parent=0, const char *name=0, bool modal=FALSE, WFlags f=0 );
	~CMultiLineEditDlg();

	bool init( QString fname, QString caption,
				bool bSave=true, bool bEdit=false, bool bShowFrame=true );

	bool init( QString caption=NULL );

public slots:
	void slotOk();
	void slotSave();

protected:
	virtual void resizeEvent( QResizeEvent * );

private:
	bool m_bShowFrame;
}; //end of class CMultiLineEditDlg

#endif // _MULTILINEEDITDLG_H_
