/************************************************************************/
/* MGIBA: Mesh Generator for Image Based Analysis                       */
/* ==============================================                       */
/*                                                                      */
/* Written by Yongchul Kim (blksaint@freechal.com)                      */
/* http://www.diniworld.com                                             */
/*                                                                      */
/* This program is free software. You can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation; either version 2 of the License.       */
/*                                                                      */
/* Please read LICENSE.txt                                              */
/************************************************************************/


#ifndef _RENDERVIEW_H_
#define _RENDERVIEW_H_

#include "global_define.h"
#include <qwidget.h>
#include <qpixmap.h>

class QSize;
class QScrollView;
class CVolume;
class RenderMDIWindow;

class CRenderViewArea;


class CRenderView : public QWidget
{
	Q_OBJECT

public:
	CRenderView( QWidget *parent=0, const char *name=0, WFlags fl=0 );
	~CRenderView();

	void init( RenderMDIWindow *pRenderMDIWindow );

	RenderMDIWindow *renderMDIWindow();
	CRenderViewArea *renderViewArea();

	QPixmap imagePixmap();

signals:
	void viewResized();

public slots:
	void slotMoveImageToCenter();

protected:
	virtual void resizeEvent( QResizeEvent * );

private:
	RenderMDIWindow *m_pRenderMDIWindow;
	
	QScrollView *m_pScrollView;
	CRenderViewArea *m_pRenderViewArea;
}; // end of class CRenderView


class CRenderViewArea : public QWidget
{
	Q_OBJECT

public:
	CRenderViewArea( QWidget *parent=0, const char *name=0, WFlags fl=0 );
	~CRenderViewArea();

	bool init( BYTE *image, int ratio );
	QPixmap imagePixmap();

protected:
	virtual void resizeEvent( QResizeEvent * );
	virtual void paintEvent( QPaintEvent * );

private:
	CRenderView *m_pParent;
	QPixmap m_Pixmap;

	QSize m_szImage;
}; // end of class CRenderViewArea

#endif // _RENDERVIEW_H_
