/************************************************************************/
/* MGIBA: Mesh Generator for Image Based Analysis                       */
/* ==============================================                       */
/*                                                                      */
/* Written by Yongchul Kim (blksaint@freechal.com)                      */
/* http://www.diniworld.com                                             */
/*                                                                      */
/* This program is free software. You can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation; either version 2 of the License.       */
/*                                                                      */
/* Please read LICENSE.txt                                              */
/************************************************************************/


#include "RenderedImageSizeDlg.h"
#include <qpushbutton.h>
#include <qradiobutton.h>
#include <qlabel.h>

CRenderedImageSizeDlg::CRenderedImageSizeDlg( QWidget *parent, const char *name, bool modal, WFlags f )
	: CRenderedImageSizeDlg_base( parent, name, modal, f )
{
	connect( IDC_BTN_OK, SIGNAL( clicked() ), this, SLOT( slotOk() ) );
	connect( IDC_BTN_CANCEL, SIGNAL( clicked() ), this, SLOT( slotCancel() ) );
} /* CRenderedImageSizeDlg */

CRenderedImageSizeDlg::~CRenderedImageSizeDlg()
{
} /* ~CRenderedImageSizeDlg */

bool CRenderedImageSizeDlg::init( int ratio )
{
	IDC_RADIO_256->setChecked( false );
	IDC_RADIO_384->setChecked( false );
	IDC_RADIO_512->setChecked( false );
	IDC_RADIO_640->setChecked( false );
	IDC_RADIO_768->setChecked( false );
	IDC_RADIO_896->setChecked( false );
	IDC_RADIO_1024->setChecked( false );
	IDC_RADIO_1152->setChecked( false );
	IDC_RADIO_1280->setChecked( false );
	IDC_RADIO_2048->setChecked( false );

	switch( ratio )
	{
	case 2:
		IDC_RADIO_256->setChecked( true );
		break;
	case 3:
		IDC_RADIO_384->setChecked( true );
		break;
	case 4:
		IDC_RADIO_512->setChecked( true );
		break;
	case 5:
		IDC_RADIO_640->setChecked( true );
		break;
	case 6:
		IDC_RADIO_768->setChecked( true );
		break;
	case 7:
		IDC_RADIO_896->setChecked( true );
		break;
	case 8:
		IDC_RADIO_1024->setChecked( true );
		break;
	case 9:
		IDC_RADIO_1152->setChecked( true );
		break;
	case 10:
		IDC_RADIO_1280->setChecked( true );
		break;
	case 16:
		IDC_RADIO_2048->setChecked( true );
		break;
	}

	IDC_LBL_DESCRIPTION->setText(
		tr(
"If you choose larger size, it takes a lot of time...\n\n\
Default size is 512 x 512." 
		) );

	return true;
} /* init */

// slot
void CRenderedImageSizeDlg::slotOk()
{
	if ( IDC_RADIO_256->isChecked() )
		m_nImageSizeRatio = 2;
	else if ( IDC_RADIO_384->isChecked() )
		m_nImageSizeRatio = 3;
	else if ( IDC_RADIO_512->isChecked() )
		m_nImageSizeRatio = 4;
	else if ( IDC_RADIO_640->isChecked() )
		m_nImageSizeRatio = 5;
	else if ( IDC_RADIO_768->isChecked() )
		m_nImageSizeRatio = 6;
	else if ( IDC_RADIO_896->isChecked() )
		m_nImageSizeRatio = 7;
	else if ( IDC_RADIO_1024->isChecked() )
		m_nImageSizeRatio = 8;
	else if ( IDC_RADIO_1152->isChecked() )
		m_nImageSizeRatio = 9;
	else if ( IDC_RADIO_1280->isChecked() )
		m_nImageSizeRatio = 10;
	else if ( IDC_RADIO_2048->isChecked() )
		m_nImageSizeRatio = 16;
	
	QDialog::accept();
} /* slotOk */

// slot
void CRenderedImageSizeDlg::slotCancel()
{
	QDialog::reject();
} /* slotCancel */
