/************************************************************************/
/* MGIBA: Mesh Generator for Image Based Analysis                       */
/* ==============================================                       */
/*                                                                      */
/* Written by Yongchul Kim (blksaint@freechal.com)                      */
/* http://www.diniworld.com                                             */
/*                                                                      */
/* This program is free software. You can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation; either version 2 of the License.       */
/*                                                                      */
/* Please read LICENSE.txt                                              */
/************************************************************************/


#ifndef _RESAMPLINGDLG_H_
#define _RESAMPLINGDLG_H_

#include "global_define.h"
#include "../BaseDialog/Image/ResamplingDlg_base.h"


class MDIWindow;
class CVolume;


class CResamplingDlg : public CResamplingDlg_base
{
	Q_OBJECT

public:
	CResamplingDlg( QWidget *parent=0, const char *name=0, bool modal=FALSE, WFlags f=0 );
	~CResamplingDlg();

	bool init( MDIWindow *pMDIWindow );

public slots:
	void slotDirectory();
	void slotDirectoryChanged( const QString & );
	void slotKeywordChanged( const QString & );
	void slotTypeChanged( int );
	void slotStartChanged( int );
	void slotEndChanged( int );
	void slotOk();
	void slotCancel();

private:
	MDIWindow *m_pMDIWindow;

	CVolume *m_pVolume;

	int m_nType;
	WORD m_nDepth;
}; // end of class CResamplingDlg

#endif // _RESAMPLINGDLG_H_
