/************************************************************************/
/* MGIBA: Mesh Generator for Image Based Analysis                       */
/* ==============================================                       */
/*                                                                      */
/* Written by Yongchul Kim (blksaint@freechal.com)                      */
/* http://www.diniworld.com                                             */
/*                                                                      */
/* This program is free software. You can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation; either version 2 of the License.       */
/*                                                                      */
/* Please read LICENSE.txt                                              */
/************************************************************************/


#include <qapplication.h>
#include "MainWindow.h"
#include "SplashDlg.h"

QApplication *g_pApp = NULL;

int main( int argc, char** argv )
{
	QApplication app( argc, argv );
	g_pApp = &app;

	// splash window
	CSplashDlg *splash = new CSplashDlg( NULL, "", false, QWidget::WType_Popup );
	splash->show();
	splash->repaint( false );
	g_pApp->processEvents();

	CMainWindow *window = new CMainWindow;
	window->init();
	app.setMainWidget( window );
	window->show();

	delete splash;

	return app.exec();
} /* main */

