/************************************************************************/
/* MGIBA: Mesh Generator for Image Based Analysis                       */
/* ==============================================                       */
/*                                                                      */
/* Written by Yongchul Kim (blksaint@freechal.com)                      */
/* http://www.diniworld.com                                             */
/*                                                                      */
/* This program is free software. You can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation; either version 2 of the License.       */
/*                                                                      */
/* Please read LICENSE.txt                                              */
/************************************************************************/


#ifndef _VTKQTRENDERWINDOW_H_
#define _VTKQTRENDERWINDOW_H_

#include <qgl.h>

#include <vtkRenderer.h>
#include <vtkRenderWindow.h>
#include <vtkLight.h>

class vtkQtRenderWindow : public QGLWidget 
{
	Q_OBJECT

public:
   vtkQtRenderWindow( QGLFormat glf, QWidget *parent = 0, const char *name = 0 );
   vtkQtRenderWindow( QWidget *parent = 0, const char *name = 0 );

   ~vtkQtRenderWindow();

   vtkRenderer *getRenderer();
   vtkRenderWindow *getRenderWindow();

protected:
   virtual void paintGL();
   virtual void initializeGL( );
   virtual void resizeGL( int w, int h );

private:
   void init();

private:
   bool m_bInitNeeded;
   vtkRenderer		*m_pVtkRenderer;
   vtkRenderWindow	*m_pVtkRenderWindow;
   vtkLight			*m_pVtkLight;
}; // end of class vtkQtRenderWindow

#endif // _VTKQTRENDERWINDOW_H_
